package number_utils

import (
	"math"
	"strconv"
)

func RoundFloat(value float64) float64 {
	return math.Round(value*100) / 100 // 2 decimal places
}

func RoundFloatTo(value float64, to int) float64 {
	toValue := math.Pow(10.0, float64(to))
	return math.Round(value*toValue) / toValue
}

func StringToInt(stringValue string) (int, error) {
	return strconv.Atoi(stringValue)
}

func StringToInt64(stringValue string) (int64, error) {
	number, err := strconv.ParseInt(stringValue, 10, 64)
	return number, err
}

func StringToFloat64(stringValue string) (float64, error) {
	number, err := strconv.ParseFloat(stringValue, 64)
	if err != nil {
		return 0, err
	}
	return number, nil
}
